#include <windows.h>
#include <WinBase.h>
#include <Shlwapi.h>
//#include <vector>
//using namespace std;

#include "Tools.h"

#pragma comment(lib, "..\\GDImage64.lib")
#pragma comment(lib, "..\\WinLIFT64.lib")

// Enable tooltip
#pragma comment(linker,"\"/manifestdependency:type='win32' \
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")

#define NM_AUDIOCOMPLETION  -80
#define NM_MOVIEPLAYING     -81

#define CLIENT_WIDTH         780
#define CLIENT_HEIGHT        440
#define CTRL_WIDTH           392
#define CTRL_HEIGHT          392

#define IDC_GDImageCTRL     -1
#define IDC_MOTORCYCLE      -2
#define IDC_static          -3
#define IDC_TIMER            1

#define ID_FIRST             1
#define ID_Layer1            ID_FIRST
#define ID_Layer2            ID_FIRST + 1
#define ID_Layer3            ID_FIRST + 2
#define ID_Layer4            ID_FIRST + 3
#define ID_Layer5            ID_FIRST + 4
#define ID_Layer6            ID_FIRST + 5
#define ID_LAST              ID_Layer6

#define ZWP_PARENT           1
#define ZWP_PLUGIN           2
#define ZWP_AUDIO            3
#define ZWP_DESTROY          4

struct PROP {
    HWND hMain;
    HWND hzwp;
    long skinactive;
    long sequence;
    long ZWPNOTIFICATION;
};

struct ZWP {
    char file[MAX_PATH];
};

PROP gP; // Global properties
COPYDATASTRUCT gCDS; ZWP gZWP;

WCHAR* EXEpath() {
    static WCHAR exepath[MAX_PATH] = { 0 };
    if (GetModuleFileName(0, exepath, sizeof(exepath))) {
        long nLen = (long)wcslen(exepath);
        long nPos = nLen;
        for (long K = 1; K <= nLen; K++) {
            if (_wcsicmp(&exepath[nPos - K], L"\\") != 0) { exepath[nPos - K] = NULL; }
            else { break; }
        }
    }
    return exepath;
}

WCHAR* EXEresource() {
    static WCHAR szResource[MAX_PATH] = { 0 };
    PathCombine(szResource, EXEpath(), L"resource\\");
    return szResource;
}

WCHAR* EXEplugin() {
    static WCHAR szResource[MAX_PATH] = { 0 };
    PathCombine(szResource, EXEpath(), L"BBplugin\\");
    return szResource;
}

void ZWP_SizeMove() {
    RECT lpw = { 0 };
    // GetWindowRect(gP.hMain, &lpw);
    // Tron3D uses the RECT of the GDImage child control instead of the main window.
    GetWindowRect(GetDlgItem(gP.hMain, IDC_GDImageCTRL), &lpw);
    long x = lpw.left;       //+ skGetSystemMetrics(SK_DWM_LEFT)
    long y = lpw.top;        //+ skGetSystemMetrics(SK_DWM_TOP)
    long w = lpw.right - x;  //- skGetSystemMetrics(SK_DWM_RIGHT)
    long h = lpw.bottom - y; //- skGetSystemMetrics(SK_DWM_BOTTOM)

    // Use this to move the window in case of AERO shake
    // because setting the new location with SetWindowPos
    // may fail!
    if (gP.hzwp) {
        HWND hPopup = skGetDWMregion(gP.hMain);
        if (hPopup == 0) { hPopup = gP.hMain; }

        SetWindowPos(gP.hzwp, GetWindow(hPopup, GW_HWNDNEXT), 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOOWNERZORDER | SWP_NOACTIVATE | SWP_ASYNCWINDOWPOS);
        MoveWindow(gP.hzwp, x, y, w, h, 0);
    }
}

void ZWP_Handle() {
    if (gP.hzwp == 0) {
        WCHAR szFile[MAX_PATH] = { 0 };
        PathCombine(szFile, EXEpath(), L"zwp.exe");
        HINSTANCE nRet = ShellExecute(0, L"open", szFile, L"", EXEpath(), SW_SHOWNOACTIVATE);
        Sleep(400);

        char zClass[] = "ZWALLPAPER";
        gP.hzwp = FindWindowA(zClass, zClass);
        if (gP.hzwp) {
            ZWP_SizeMove();

            gCDS.dwData = ZWP_PARENT;
            gCDS.cbData = sizeof(gZWP);
            gCDS.lpData = &gZWP;
            SendMessage(gP.hzwp, WM_COPYDATA, (WPARAM) gP.hMain, (LPARAM) &gCDS);
        }
    }
}

void ZWP_Destroy() {
    if (gP.hzwp) {
         gCDS.dwData = ZWP_DESTROY;
         gCDS.cbData = sizeof(gZWP);
         gCDS.lpData = &gZWP;
         SendMessage(gP.hzwp, WM_COPYDATA, (WPARAM) gP.hMain, (LPARAM) &gCDS);
    }
}

void ZWP_Play(IN WCHAR* szFile, IN long nFileType) {
    if (gP.hzwp) {
        ZWP_SizeMove();
        memset(gZWP.file, 0, MAX_PATH);
        WideCharToMultiByte(CP_ACP, 0, szFile, -1, gZWP.file, MAX_PATH, NULL, NULL);
        gCDS.dwData = nFileType;
        gCDS.cbData = sizeof(gZWP);
        gCDS.lpData = &gZWP;
        SendMessage(gP.hzwp, WM_COPYDATA, (WPARAM) gP.hMain, (LPARAM) &gCDS);
        ShowWindow(gP.hzwp, SW_SHOW);
    }
}

void RenderAnimation(IN HWND hWnd) {
    long nX = 0, nY = 0, nW = 0, nH = 0; HWND hCtrl = 0;
    RECT rc = { 0 }; POINT p = { 0 };
    static long nFlip, AnimDone;
    static DWORD nTempo;

    if (nTempo < GetTickCount()) {

        ZD_GetObjectXY(ID_Layer2, nX, nY);
        if (nFlip == 0) {
            if (nX > -68) {
                nX -= 2;
            } else {
                nFlip = -1;
            }
        } else {
            if (nX < 0) {
                nX += 2;
            } else {
                nFlip = 0;
            }
        }

        ZD_SetObjectRed(ID_Layer1, (BYTE) (187 + nX), FALSE);
        ZD_SetObjectBlue(ID_Layer1, (BYTE) (-nX * 2), FALSE);

        ZD_SetObjectXY(ID_Layer2,  nX, nY, FALSE);
        ZD_SetObjectXY(ID_Layer3, -nX, nY, FALSE);

        ZD_SetObjectAngle(ID_Layer5, -nX, FALSE);

        if (gP.sequence == 1) {
            ZD_SetObjectAlpha(ID_Layer6, (BYTE) (255 + nX), FALSE);
            ZD_SetObjectScale(ID_Layer6, 1 + (-nX * 0.005f));
        } else {
            ZD_SetObjectScale(ID_Layer6, 3 - (1 + (-nX * 0.005f) * 4));
        }

        ZI_UpdateWindow(GetDlgItem(hWnd, IDC_GDImageCTRL), 0);

        nTempo = GetTickCount() + 40;
    }

    if (AnimDone == 0) {
        hCtrl = GetDlgItem(hWnd, IDC_MOTORCYCLE);
        GetWindowRect(hCtrl, &rc); p.x = rc.left; p.y = rc.top; ScreenToClient(GetParent(hCtrl), &p);
        if (p.x > 2) {
            p.x -= 2;
            nH = rc.bottom - rc.top; GetClientRect(GetParent(hCtrl), &rc); nW = rc.right - rc.left;
            MoveWindow(hCtrl, p.x, p.y, nW - p.x, nH, 1);
            ZI_SetAnchorMode(hCtrl, ANCHOR_WIDTH);
        } else {
            AnimDone = -1;
        }
    }
}

LRESULT CALLBACK WndProc(IN HWND hWnd, IN UINT uMsg, IN WPARAM wParam, IN LPARAM lParam) {
    long nRet = 0;
    WCHAR szFile[MAX_PATH] = { 0 };

    if (uMsg == gP.ZWPNOTIFICATION) {

        if ((long) wParam == NM_AUDIOCOMPLETION) {
            gP.sequence++;
            if (gP.sequence > 2) { gP.sequence = 1; }

            if (gP.sequence == 1) {
                PathCombine(szFile, EXEplugin(), L"Hud_Ring.dll"); ZWP_Play(szFile, ZWP_PLUGIN);
                PathCombine(szFile, EXEresource(), L"TronGRID.ogg"); ZWP_Play(szFile, ZWP_AUDIO);
                PathCombine(szFile, EXEresource(), L"Layer6.png");
                ZD_SetObjectBitmapFromFile(szFile, ID_Layer6, TRUE);
            } else {
                PathCombine(szFile, EXEplugin(), L"Hud_Beam.dll"); ZWP_Play(szFile, ZWP_PLUGIN);
                PathCombine(szFile, EXEresource(), L"TronSOF.ogg"); ZWP_Play(szFile, ZWP_AUDIO);
                ZD_SetObjectScale(ID_Layer6, 1);
                ZD_SetObjectAlpha(ID_Layer6, 255, FALSE);
                PathCombine(szFile, EXEresource(), L"Layer6_bis.png");
                ZD_SetObjectBitmapFromFile(szFile, ID_Layer6, TRUE);
            }
        }
        return 0;
    }

    switch (uMsg) {

    case WM_SIZE:
    case WM_MOVE:
    case WM_WINDOWPOSCHANGED:
    case WM_IME_NOTIFY:
         ZWP_SizeMove();
         break;

    case WM_DROPFILES: // Drag & drop
         nRet = DragQueryFile((HDROP) wParam, -1, L"", 0);
         if (nRet > 0) {
             nRet = DragQueryFile((HDROP) wParam, 0, szFile, MAX_PATH);
             if (nRet > 0) { ZWP_Play(szFile, ZWP_AUDIO); }
         }
         DragFinish((HDROP) wParam);
         break;

    case WM_ERASEBKGND:
         return 1;

    case WM_TIMER:
         RenderAnimation(hWnd);
         return 0;

    case WM_DESTROY:
         ZWP_Destroy();
         PostQuitMessage(0);
         return 0;
    }
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {
    UNREFERENCED_PARAMETER(hPrevInstance);
    long nRet = 0;
    MSG msg = { 0 };
    RECT r = { 0 };
    WNDCLASSEX wcx = { 0 };
    WCHAR szFile[MAX_PATH] = { 0 };
    WCHAR zClass[] = L"ZTRON";

    HANDLE hMutex = CreateMutex(NULL, 0, zClass);
    if (hMutex) {
        if (GetLastError() == ERROR_ALREADY_EXISTS) {
            for (;;) { // Do/Loop
                gP.hMain = FindWindow(zClass, L""); if (gP.hMain) { break; }
                while (PeekMessage(&msg, NULL, NULL, NULL, PM_REMOVE)) { }
            }
            if (IsIconic(gP.hMain)) { ShowWindow(gP.hMain, SW_RESTORE); }
            SetForegroundWindow(gP.hMain);
            return nRet;
        }
    }

    wcx.cbSize = sizeof(wcx);
    long IsInitialized = GetClassInfoEx(hInstance, zClass, &wcx);
    if (!IsInitialized) {
        wcx.style         = 0; // CS_HREDRAW | CS_VREDRAW
        wcx.lpfnWndProc   = WndProc;
        wcx.cbClsExtra    = 0;
        wcx.cbWndExtra    = 0;
        wcx.hInstance     = hInstance;
        wcx.hIcon         = LoadIcon(wcx.hInstance, L"PROGRAM");
        wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wcx.hbrBackground = NULL;
        wcx.lpszMenuName  = NULL;
        wcx.lpszClassName = zClass;
        wcx.hIconSm       = wcx.hIcon;
        if (RegisterClassEx(&wcx)) { IsInitialized = -1; }
    }

    if (IsInitialized) {
        DWORD dwStyleEx = 0, dwStyle = WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX;

        SetRect(&r, 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT);
        AdjustWindowRectEx(&r, dwStyle, FALSE, dwStyleEx);
        long w = r.right - r.left;
        long h = r.bottom - r.top;
        long x = max((GetSystemMetrics(SM_CXSCREEN) - w) / 2, 0);
        long y = max((GetSystemMetrics(SM_CYSCREEN) - h) / 2, 0);

        gP.hMain = CreateWindowEx(dwStyleEx, zClass, L"", dwStyle, x, y, w, h, NULL, NULL, hInstance, NULL);
        if (gP.hMain) {

            gP.ZWPNOTIFICATION = RegisterWindowMessageA("ZWPnotification");

            dwStyle = WS_CHILD | WS_VISIBLE;
            x = (CLIENT_WIDTH - CTRL_WIDTH) / 2;
            y = (CLIENT_HEIGHT - CTRL_HEIGHT) / 2 + 12;
            HWND hCtrl = CreateWindowEx(0, GDImageClassName, L"", dwStyle, x, y, CTRL_WIDTH, CTRL_HEIGHT, gP.hMain, (HMENU) IDC_GDImageCTRL, hInstance, NULL);
            ZI_SetAnchorMode(hCtrl, ANCHOR_CENTER);
            // Gradiant color to paint the background
            ZI_TRIVERTEX(1, 1); // Use TRIVERTEX rather than GDI+
            ZI_SetProperty(hCtrl, ZI_GradientTop, RGB(1,64,85));
            ZI_SetProperty(hCtrl, ZI_GradientBottom, 0);
            HBITMAP hBitmap = 0;
            for (long nID = ID_FIRST; nID <= ID_LAST; nID++) {
                PathCombine(szFile, EXEresource(), L"Layer");
                wcsncat_s(szFile, STRL(nID), 1); wcsncat_s(szFile, L".png", 4);
                hBitmap = ZI_CreateBitmapFromFile(szFile, w, h);
                ZD_DrawBitmapToCtrl(hCtrl, 0, 0, hBitmap, ZD_ColorARGB(255, 0), nID, ZS_VISIBLE);
                ZD_SetObjectLocked(nID, TRUE);
            }

            if (skInitEngine(L"Tron.sks", L"")) {
                skSkinWindow(gP.hMain, L"Dock|Undock|Minimize|Maximize|Restore|Close");
                gP.skinactive = -1;
                PathCombine(szFile, EXEresource(), L"MotorCycle.png");
                hCtrl = skPushButtonImage(gP.hMain, szFile, L" ", CLIENT_WIDTH + 4, 0, CLIENT_WIDTH + 4, 24, IDC_MOTORCYCLE, BS_LEFT);
                EnableWindow(hCtrl, FALSE);
            }

            // To perform audio file drag and drop
            DragAcceptFiles(gP.hMain, TRUE);

            // Run ZWP with the default plugin
            ZWP_Handle();
            PathCombine(szFile, EXEplugin(), L"Hud_Ring.dll"); ZWP_Play(szFile, ZWP_PLUGIN);
            PathCombine(szFile, EXEresource(), L"TronGRID.ogg"); ZWP_Play(szFile, ZWP_AUDIO);

            // Show the main window
            ShowWindow(gP.hMain, SW_SHOW);
            SetForegroundWindow(gP.hMain); // Slightly Higher Priority

            gP.sequence = 1;

            SetTimer(gP.hMain, IDC_TIMER, 0, NULL);
            while (GetMessage(&msg, NULL, 0, 0)) {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
            KillTimer(gP.hMain, IDC_TIMER);

            nRet = (long) msg.wParam;
        }
    }

    if (hMutex) { CloseHandle(hMutex); }
    return nRet;
}
